/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.decoder;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.x86.op.MOV_M16IMM16;
import ru.ispras.microtesk.model.x86.mode.RSEG16;
import ru.ispras.microtesk.model.api.IsaPrimitive;
import ru.ispras.microtesk.model.x86.mode.IMM16;

/**
 * The {@code DecoderMOV_M16IMM16} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderMOV_M16IMM16 extends DecoderItem {
  private static DecoderMOV_M16IMM16 instance = null;

  public static DecoderMOV_M16IMM16 get() {
    if (null == instance) {
      instance = new DecoderMOV_M16IMM16();
    }
    return instance;
  }

  private DecoderMOV_M16IMM16() {
    super(
        57,
        false,
        null,
        null
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    RSEG16 seg_ovrd = null;
    IsaPrimitive dst = null;
    IMM16 src = null;

    if (!matchNextOpc(image, BitVector.valueOf("001", 2, 3))) {
      return null;
    }

    seg_ovrd = (RSEG16) readNextPrimitive(image, DecoderRSEG16.get());
    if (null == seg_ovrd) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("11011000111", 2, 11))) {
      return null;
    }


    if (!matchNextOpc(image, BitVector.valueOf("001", 2, 3))) {
      return null;
    }


    dst = (IsaPrimitive) readNextPrimitive(image, DecoderMOFFS.get());
    if (null == dst) {
      return null;
    }

    src = (IMM16) readNextPrimitive(image, DecoderIMM16.get());
    if (null == src) {
      return null;
    }

    return newResult(new MOV_M16IMM16(seg_ovrd, dst, src));
  }
}
